option explicit
''
''
'' input:	OBJ file format (only triagles!; (un)welded)
'' output:	JOT file format (only vertices, faces, texcoords2; no creases...)
'' 
''
call get_obj_file() 
''
''
sub get_obj_file()

  dim extension, file, bln
  dim file_name
  dim fso       : set fso = createobject( "scripting.filesystemobject" )
  dim dir_name  : set dir_name = fso.getfolder( ".\" )
  dim file_list : set file_list = dir_name.files

  for each file in file_list
    extension = lcase( fso.getextensionname( file ) )
    if ( extension = "obj" ) then
      file_name = split( file.name, "." )
      bln = vbyes
      if ( fso.fileexists( file_name(0) & ".jot" ) ) then bln = vbno
''      bln = msgbox( file_name( 0 ) & ".jot file already exists! overwrites?", 36 )
      if ( bln = vbyes ) then call jot( file_name(0) )
    end if  
  next

  call msgbox( "complete! enjoy yourself...", , ":: script :: obj2jot ::" )

end sub
''
''
sub jot( id )
  
  dim mesh_name
  dim v_count : v_count = 0
  dim f_count : f_count = 0
  dim vt_count : vt_count = 1
  dim decr : decr = 1
  dim obj_line, items 
  dim vertex(), face(), vt(), texc()
  dim fso : set fso = createobject( "scripting.filesystemobject" )
  dim obj_file : set obj_file = fso.opentextfile( id & ".obj", 1 )
  dim jot_file : set jot_file = fso.createtextfile( id & ".jot", true )

  jot_file.writeline( "#jot" & vbcrlf )

  do while ( obj_file.atendofstream <> true )
    obj_line = split( obj_file.readline, " ", -1, 1)
    if ( ubound( obj_line ) = -1 ) then obj_line = array( "^$" )
    select case ( obj_line(0) )
      case ( "o" )
 	if ( not ( isempty( mesh_name ) ) ) then
	  call mesh( jot_file, mesh_name, vertex, face, texc )
 	  decr = decr + v_count
 	  redim vertex(0) : v_count = 0
 	  redim   face(0) : f_count = 0
 	  redim   texc(0)
 	end if  
	mesh_name = obj_line(1)
      case ( "v" )
        redim preserve vertex( v_count )
	vertex(v_count) = (				_
	                     "{" &			_
			     obj_line(1) & " " &	_
			     obj_line(2) & " " &	_
			     obj_line(3) & " }"		_
		           )
	v_count = v_count + 1
      case ( "vt" )
        redim preserve vt(vt_count)
	vt(vt_count) = (			_
	                  "{" &			_
			  obj_line(1) & " " &	_
			  obj_line(2) & " }"	_
		        )
	vt_count = vt_count + 1
      case ( "f" )
        if ( ubound( obj_line ) > 3 ) then
	  call msgbox(							_
	               "quad or n-gons in the " & id & ".obj file!"	_
		       & "; file will be omitted;" & vbcrlf &		_
		       "jot processes only triangle meshes!"		_
                       ,, ":: script :: moi2jot ::"			_
		     )
	  jot_file.close
          call fso.deletefile( id & ".jot" )
	  exit sub 
	end if
        redim preserve face(f_count)
        items = array(						_
	               split( obj_line(1), "/", -1, 1 ),	_
		       split( obj_line(2), "/", -1, 1 ),	_
		       split( obj_line(3), "/", -1, 1 )	_
		     )
	face(f_count) = (					_
	                    "{" &				_
	                    ( items(0)(0) - decr ) & " " &	_ 
	                    ( items(1)(0) - decr ) & " " &	_
		            ( items(2)(0) - decr ) & " }"	_
		          )
        if vt_count > 1 then
	  redim preserve texc(f_count)
	
	  texc(f_count) = (				_
      	                      "{" & f_count & " " &	_
      			      vt( items(0)(1) ) &	_
      			      vt( items(1)(1) ) &	_
      			      vt( items(2)(1) ) &	_
      			      "}"			_
      		            )
	end if
	f_count = f_count + 1
      case else
''	s, o, vn
    end select
  loop

  call mesh( jot_file, mesh_name, vertex, face, texc )

  jot_file.writeline( "CHNG_CAM 	{ {-25 25 -25 }{2.5 2.5 -2.5 }{-25 25 -25 }{2.5 2.5 -2.5 }0.16 1 2.25 " )
  jot_file.writeline( "	} " )
  jot_file.writeline( "CHNG_WIN 	{ 10 10 640 480 " )
  jot_file.writeline( "	} " )
  jot_file.writeline( "CHNG_VIEW 	{ " )
  jot_file.writeline( "	VIEW 	{ " )
  jot_file.writeline( "		view_animator 	{ " )
  jot_file.writeline( "			Animator 	{ " )
  jot_file.writeline( "				fps 	-1 " )
  jot_file.writeline( "				start_frame 	-1 " )
  jot_file.writeline( "				end_frame 	-1 " )
  jot_file.writeline( "				name 	{ NULL_STR } " )
  jot_file.writeline( "				} } " )
  jot_file.writeline( "		view_data_file 	{ NULL_STR } " )
  jot_file.writeline( "		} " )
  jot_file.writeline( "	} " )
  jot_file.close
  obj_file.close

end sub
''
''
sub mesh( m, n, v, f, t )
  
  m.writeline( "TEXBODY 	{ " )
  m.writeline( "	name 	" & n & " " )
  m.writeline( "	xform 	{{1 0 0 0 }{0 1 0 0 }{0 0 1 0 }{0 0 0 1 }} " )
''m.writeline( "	xfdef 	{ DEFINER " )
''m.writeline( "		DEFINER 	{ " )
''m.writeline( "			out_mask 	1 " )
''m.writeline( "			inputs 	{ } " )
''m.writeline( "			} } " )
''m.writeline( "	color 	{1 1 1 } " )
  m.writeline( "	mesh_data 	{ " )
  m.writeline( "		LMESH 	{ " )
  m.writeline( "			vertices 	{ {" & join( v, "" ) & "}}" )
  m.writeline( "			faces 	{ {" & join( f, "" ) & "}}" )
  m.writeline( "			texcoords2 	{ {" & join( t, "" ) & "}}" )
  m.writeline( "			patch 	{ " )
  m.writeline( "				Patch 	{ " )
  m.writeline( "					cur_tex 	0 " )
  m.writeline( "					patchname 	patch-0 " )
''m.writeline( "					color 	{1 1 1 } " )
  m.writeline( "					texture 	{ " )
  m.writeline( "						Flat Shading 	{ " )
  m.writeline( "							} } " )
''m.writeline( "					texture 	{ " )
''m.writeline( "						Color ID 	{ " )
''m.writeline( "							} } " )
''m.writeline( "					texture 	{ " )
''m.writeline( "						NPRTexture 	{ " )
''m.writeline( "							npr_data_file 	{ NULL_STR } " )
''m.writeline( "							} } " )
  m.writeline( "					} } " )
  m.writeline( "			} } " )
  m.writeline( "	mesh_data_file 	{ NULL_STR } " )
  m.writeline( "	} " )
  m.writeline( "CREATE 	{ " & n & " " )
  m.writeline( "	} " )

end sub
''
''
